﻿# coding: utf-8
import sys
import os
import cookielib, urllib, urllib2
import re
import datetime

from oblovesite import *
import get_evaluation
import website

ENCODING = 'utf-8'
HOST = 'hostname'
USERNAME = 'username'
PASSWORD = 'password'


class WikiSite(website.WebSite):
    '''
    PukiWikiのサイトへのアクセスを提供する。
    '''
    def edit(self, wikiname, contents):
        page = self.get('pukiwiki.php?cmd=edit&page=' + wikiname)
        params = {}
        m = re.search('<input type="hidden" name="page" value="([^"]*)"', page)
        if m is not None:
            params['page'] = m.group(1)
        m = re.search('<input type="hidden" name="digest" value="([^"]*)"', page)
        if m is not None:
            params['digest'] = m.group(1)
        m = re.search('<input type="submit" name="write" value="([^"]*)"', page)
        if m is not None:
            params['write'] = m.group(1)
        params['msg'] = contents.encode('euc-jp', 'ignore')

        self.post(params)
        

    def read(self, wikiname):
        page = self.get('pukiwiki.php?cmd=edit&page=' + wikiname)
        params = {}
        m = re.search('<textarea name="msg" rows="20" cols="80" wrap="virtual">([^<]*)</textarea>', page)
        if m is not None:
            msg = m.group(1).decode('euc-jp', 'ignore')
        else:
            msg = u''
        return msg
        

def wiki_table(table):
    text = ""
    for r in table.rows:
        for c in r.cells:
            text += "|"
            if hasattr(c, 'color'):
                text += "COLOR(" + c.color + "):"
            text += unicode(c.value)
        text += "|\n"
    return text


def update_diff(repo):
    t = get_evaluation.latest_diff(repo)
    table_unicode = wiki_table(t)
    msg = u"'''このページは[[やっとむ]]作のスクリプトが自動生成したものです。'''\n\n" + table_unicode

    site = WikiSite("http://" + HOST + "/pukiwiki/", ENCODING, HOST, "please enter username and password!!", USERNAME, PASSWORD)
    site.edit('%5B%5B%A5%E1%A5%EB%A5%DE%A5%AC%B5%AD%BB%F6%C9%BE%B2%C1%BA%C7%BF%B7%C8%C7%5D%5D', msg)

def reader_count(repo, count, last_count):
    site = WikiSite("http://" + HOST + "/pukiwiki/", ENCODING, HOST, "please enter username and password!!", USERNAME, PASSWORD)
    msg = site.read('%5B%5B%A5%E1%A5%EB%A5%DE%A5%AC%A5%E6%A1%BC%A5%B6%BF%F4%28%BC%AB%C6%B0%BD%B8%B7%D7%29%5D%5D')
    #msg += '|%s|%s|%+d|\n'%(datetime.datetime.now().strftime("%Y/%m/%d(%a) %H:%M"), str(count), int(count)-int(last_count))
    header = msg[:msg.index('|\n')+2]
    older = msg[msg.index('|\n')+2:]
    msg = header + '|%s|%s|%+d|\n'%(datetime.datetime.now().strftime("%Y/%m/%d(%a) %H:%M"), str(count), int(count)-int(last_count)) + older
    site.edit('%5B%5B%A5%E1%A5%EB%A5%DE%A5%AC%A5%E6%A1%BC%A5%B6%BF%F4%28%BC%AB%C6%B0%BD%B8%B7%D7%29%5D%5D', msg)

def main():
    cmd = sys.argv[1]
    repo = get_evaluation.EvaluationRepository()

    if cmd == "update_diff":
        update_diff(repo)
    elif cmd == "magazine_reader_count":
        reader_count(repo, sys.argv[2], sys.argv[3])
    else:
        raise "No cmd found."


if __name__ == '__main__':
    main()


