﻿# coding: utf-8

class Table:
    def __init__(self):
        self.rows = []
        self.row_idx = 0

    def add_row(self):
        self.row_idx += 1

    def get_current_row(self):
        if self.row_idx >= len(self.rows):
            r = Row()
            self.rows.append(r)
        return self.rows[self.row_idx]

    def add_cell(self, value):
        return self.get_current_row().add_cell(value)

    def row_count(self):
        return len(self.rows)

    def col_count(self, row_idx):
        return len(self.rows[row_idx].cells)

    def value(self, col_idx, row_idx):
        row = self.rows[row_idx]
        return row.value(col_idx)

    def get_cell(self, col_idx, row_idx):
        row = self.rows[row_idx]
        return row.get_cell(col_idx)

    def csv(self, encoding="utf-8"):
        text = ""
        for r in self.rows:
            first = True
            for c in r.cells:
                if not first:
                    text += ","
                else:
                    first = False
                value = c.value
                if value is None:
                    text += ""
                elif type(value) == type(""):
                    text += value
                elif type(value) == type(u""):
                    text += c.value.encode(encoding)
                else:
                    text += str(value)
            text += "\n"
        return text


class Row:
    def __init__(self):
        self.cells = []

    def add_cell(self, value):
        cell = Cell(value)
        self.cells.append(cell)
        return cell

    def value(self, col_idx):
        return self.cells[col_idx].value

    def get_cell(self, col_idx):
        return self.cells[col_idx]


class Cell:
    def __init__(self, value=None):
        self.value = value


