﻿# coding: utf-8
import sys
import os
import cookielib, urllib, urllib2
import re
import datetime
import base64

from oblovesite import *
import get_evaluation
import website
import pukiwiki

ENCODING = 'utf-8'
HOST = 'hostname'
#HOST = '127.0.0.1'
USERNAME = 'username'
PASSWORD = 'password'
CSV_PATTERN = re.compile('^.*<pre>\n(.*)</pre>.*$', re.DOTALL)
STAT_MESSAGE = u'''
更新日時: %(date)s
-講演会: %(seminar)d
-懇親会: %(party)d
-午前1: A=%(seminarA)d, B=%(seminarB)d
-午前2: C=%(seminarC)d, D=%(seminarD)d
-午後: E=%(seminarE)d, F=%(seminarF)d
-XFD: %(xfd)d
-トークス: 参加=%(talker)d, 検討=%(talkercandidate)d
'''

class ZopeSite(website.WebSite):
    '''
    Zopeのサイトへのアクセスを提供する。
    '''
    firsttime = True
    def get_csv(self, url):
        page = self.get(url).decode('utf-8')
        csv = []
        for line in CSV_PATTERN.sub('\\1', page).split('\n'):
            if line.find(',') < 0:
                continue
            csv.append(self.split_csv(line))
        return csv

    def split_csv(self, line):
        row = []
        cell = ''
        in_quotes = False
        for c in line:
            if c==u'"' and in_quotes:
                in_quotes = False
            elif c==u'"' and not in_quotes:
                in_quotes = True
            elif c==u',' and not in_quotes:
                row.append(cell)
                cell = u''
            else:
                cell = cell + c
        row.append(cell)
        return row

    def get(self, url, headers={}):
        headers['Authorization'] = 'Basic ' + base64.b64encode(USERNAME + ':' + PASSWORD)
        return website.WebSite.get(self, url, headers)

def read_csv():
    site = ZopeSite(baseurl="http://" + HOST + ":9090/", encoding=ENCODING, host=HOST, realm="Zope", username=USERNAME, password=PASSWORD)
    data = site.get_csv('plone/event/regist20061220/view_csv')
    for l in data:
        # 個人情報を含むカラムを削除する。右から消さないとインデックスがわからなくなる。
        # 元データのカラムはこう："番号","名前","ふりがな","会社","所属","メール","住所","講演会","懇親会","アルコール","午前1","午前2","午後1","トークス","トークス会社名","トークス氏名","領収証","宛名","何か一言","案内"
        del l[17],l[15],l[14],l[6],l[5],l[4],l[3],l[2],l[1]
    return data

def write_entries(data):
    text = build_stat_text(data)
    for line in data:
        for cell in line:
            text += '|' + cell
        text += '|\n'
    text += '\n'
    text += u'凡例: 1/0 - あり/なし, トークス＝0/1/2 - 不参加/参加/検討中\n'

    wikisite = pukiwiki.WikiSite("http://" + pukiwiki.HOST + "/pukiwiki/", pukiwiki.ENCODING, pukiwiki.HOST, "please enter username and password!!", pukiwiki.USERNAME, pukiwiki.PASSWORD)
    wikisite.edit('%5B%5B2006ChristmasEvent%BF%BD%B9%FE%BE%F5%B6%B7%5D%5D', text)

def build_stat_text(data):
    data = data[1:]
    params = {}
    params['date'] = datetime.datetime.now().strftime("%Y/%m/%d(%a) %H:%M")
    params['seminar'] = [row[1] for row in data].count('1')
    params['party'] = [row[2] for row in data].count('1')
    params['seminarA'] = [row[4] for row in data].count('A')
    params['seminarB'] = [row[4] for row in data].count('B')
    params['seminarC'] = [row[5] for row in data].count('C')
    params['seminarD'] = [row[5] for row in data].count('D')
    params['seminarE'] = [row[6] for row in data].count('E')
    params['seminarF'] = [row[6] for row in data].count('F')
    params['xfd'] = [row[4] for row in data].count('X')
    params['talker'] = [row[7] for row in data].count('1')
    params['talkercandidate'] = [row[7] for row in data].count('2')
    return STAT_MESSAGE%params

def main():
    cmd = sys.argv[1]

    if cmd == "csv":
        csv = read_csv()
        write_entries(csv)
    else:
        raise "No cmd found."


if __name__ == '__main__':
    main()


